iqHelper = {

launchiq: function(action, url)
	{
		this.run(this.getiqLocation(), Array(action + url));
},


run: function(filename, data)
{
    try
    {
      var len = 0;
      if (data)
        len = data.length;
      else
        data = null;
      var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(filename);
      if (file.isFile() && file.isExecutable())
      {
        try
				{
					var process = Components.classes['@mozilla.org/process/util;1'].createInstance(Components.interfaces.nsIProcess);
					process.init(file);
					data = process.run(false, data, len);
				}
				catch (e)
				{
				}
      }
    }
    catch(e)
    {
    }
    return data;
},

getiqLocation: function()
{
	const exeName = "InfoQubeclipper.exe";
	const usbLocationFile = "InfoQubeApp.loc";

	var ret = exeName;
	try	// first try to locate %TEMP%\InfoQubeApp.loc
	{
		var filename = this.getTempDir(false) + usbLocationFile;
		var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(filename);
		if (file.exists())
		{
			var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
			fstream.init(file, -1, 0, 0);
			var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			sstream.init(fstream); 
			ret = sstream.read(sstream.available());
			ret = ret + "InfoQubeclipper.exe"
			sstream.close();
			fstream.close();
			if (ret.length && this.getFileExists(ret))
				return ret;
		}
	}
	catch (e)
	{
			// clear the error
	}
},

getFileExists: function(filename)
{
	var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(filename);
	return file.exists();
},

getTempDir: function(iqDir)
{
	// get the system 'temp' directory
	var folder = Components.classes["@mozilla.org/file/directory_service;1"]
	.getService(Components.interfaces.nsIProperties)
        .get("TmpD", Components.interfaces.nsIFile);
		// ensure that the InfoQube subfolder exists (create if necessary)
	if (iqDir)
	{
		folder.append("InfoQube");
		if(!folder.exists() || !folder.isDirectory())    // if it doesn't exist, create
			folder.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
	}
	return folder.path + '\\';
},

writeFile: function(fileContent, filename, fileDate)
{
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(filename);
	if (file.exists())
		file.remove(true);
	file.create(file.NORMAL_FILE_TYPE, 0666);
	if (fileDate)
		file.lastModifiedTime = fileDate;

	var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
	stream.init(file, 0x02, 0x200, false); // open as "write only"
	stream.write(fileContent, fileContent.length);
	stream.close();
	return file;
}

}
